﻿namespace DocuMed.Domain.Entities.City;

[AdaptTwoWays("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[GenerateMapper]
public partial class Section : ApiEntity
{

    public Section()
    {

    }

    public Section(string name, string detail, Guid universityId)
    {
        Name = name;
        Detail = detail;
        UniversityId = universityId;
    }

    public string Name { get; internal set; } = string.Empty;
    public string Detail { get; internal set; } = string.Empty;

    public Guid UniversityId { get; internal set; }
    public University? University { get; internal set; }
}