﻿namespace DocuMed.Domain.Entities.MedicalHistory;


public partial class MedicalHistoryAnswer
{
    public static MedicalHistoryAnswer Create(
        string answer,
        string question,
        MedicalHistoryPart part,
        MedicalHistoryQuestionType questionType,
        Guid medicalHistoryId)
    {
        return new MedicalHistoryAnswer(answer, question, part, questionType, medicalHistoryId);
    }
}
public partial class MedicalHistory
{
    public MedicalHistoryAnswer AddAnswer(string answer, string question, MedicalHistoryPart part, MedicalHistoryQuestionType questionType)
    {
        var mhAnswer = MedicalHistoryAnswer.Create(answer, question, part, questionType, Id);
        Answers.Add(mhAnswer);
        return mhAnswer;
    }
    public static MedicalHistory Create(
        string chiefComplaint,
        Guid sectionId,
        string firstName,
        string lastName,
        string fatherName,
        string nationalId,
        int age,
        DateTime birthDate,
        string presentIllnessDetail,
        string pastDiseasesHistoryDetail,
        string pastSurgeryHistoryDetail,
        string familyHistoryDetail,
        string allergyDetail,
        string drugHistoryDetail,
        string addictionHistoryDetail,
        string systemReviewDetail,
        string vitalSignDetail,
        string generalAppearanceDetail,
        double systolicBloodPressure,
        double diastolicBloodPressure,
        double pulseRate,
        double sPO2,
        double temperature,
        Guid applicationUserId,
        Guid medicalHistoryTemplateId)
    {
        return new MedicalHistory(presentIllnessDetail,
            pastDiseasesHistoryDetail,
            pastSurgeryHistoryDetail,
            familyHistoryDetail,
            allergyDetail,
            drugHistoryDetail,
            addictionHistoryDetail,
            systemReviewDetail,
            vitalSignDetail,
            generalAppearanceDetail,
            chiefComplaint, 
            sectionId, 
            firstName, 
            lastName, 
            fatherName, 
            nationalId, 
            age, 
            birthDate, 
            systolicBloodPressure,
            diastolicBloodPressure, 
            pulseRate, 
            sPO2, 
            temperature, 
            applicationUserId,
            medicalHistoryTemplateId);
    }

}