﻿namespace DocuMed.Domain.Entities.MedicalHistoryTemplate;

[AdaptTwoWays("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[AdaptTwoWays("[name]LDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[GenerateMapper]



public partial class MedicalHistoryTemplate : ApiEntity
{
    public MedicalHistoryTemplate()
    {
            
    }
    public MedicalHistoryTemplate(string chiefComplaint,Guid sectionId,Guid applicationUserId)
    {
        ChiefComplaint = chiefComplaint;
        SectionId = sectionId;
        ApplicationUserId = applicationUserId;
    }

    public string ChiefComplaint { get; internal set; } = string.Empty;
    public Guid SectionId { get; set; }
    public Section? Section { get; set; }
    public Guid ApplicationUserId { get; internal set; }
    public ApplicationUser? ApplicationUser { get; set; }
    public List<MedicalHistoryQuestion> Questions { get; internal set; } = new();
}