﻿namespace DocuMed.Domain.Entities.User;

[AdaptTwoWays("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[GenerateMapper]
public class ApplicationUser : IdentityUser<Guid>
{
    public string FirstName { get; set; } = string.Empty;
    public string LastName { get; set; } = string.Empty;
    public string NationalId { get; set; } = string.Empty;
    public string StudentId { get; set; } = string.Empty;
    public DateTime BirthDate { get; set; }
    public Gender Gender { get; set; }
    public SignUpStatus SignUpStatus { get; set; }

    public Guid? UniversityId { get; set; }
    public University? University { get; set; }

    public Guid? SectionId { get; set; }
    public Section? Section { get; set; }
}
